#include <windows.h>
#include <stdio.h>
#include "winsrl.h"
#include "typedefs.h"

SERIAL_CONNECTION SerialConnection;

unsigned char init_serial(void)
{
	BuildDefaultSerialConnectionStruct(&SerialConnection);
	SerialConnection.dwBaudRate = CBR_9600;
	if (!OpenComPort(&SerialConnection))
	{
		printf("Failed to open comm port\n Press any key to exit .....\n");
		return 1;
	}
	else
		return 0;
}


void set_pc_serial_timeout(DWORD timeout_val)
{
	COMMTIMEOUTS CommTimeOuts;

	// Set up Comm port timeouts for read and write
	CommTimeOuts.ReadIntervalTimeout = 0;
	CommTimeOuts.ReadTotalTimeoutMultiplier = timeout_val;
	CommTimeOuts.ReadTotalTimeoutConstant = 0;
	// CBR_9600 is approximately 1byte/ms. For our purposes, allow
	// double the expected time per character for a fudge factor.
	CommTimeOuts.WriteTotalTimeoutMultiplier = timeout_val;
	CommTimeOuts.WriteTotalTimeoutConstant = 0;
	SetCommTimeouts( SerialConnection.idComDev, &CommTimeOuts );
}


void send_char_serial(char s)
{
	WriteCommBlock( &SerialConnection, (LPSTR)&s, 1);
}


DWORD receive_char_serial(char *r)
{
	return ReadCommBlock( &SerialConnection, (LPSTR)r, 1 );
}


DWORD receive_16bit_serial(short *r16)
{
	return ReadCommBlock( &SerialConnection, (LPSTR)r16, 2);
}


DWORD receive_32bit_serial(int *r32)
{
	return ReadCommBlock( &SerialConnection, (LPSTR)r32, 4);
}


void send_16bit_serial(short r16)
{
	WriteCommBlock( &SerialConnection, (LPSTR)&r16, 2);
}


void send_32bit_serial(int r32)
{
	WriteCommBlock( &SerialConnection, (LPSTR)&r32, 4);
}
